// OptionDlgEx.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "OptionDlg.h"
#include "OptionDlgEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDlgEx _CAO


COptionDlgEx::COptionDlgEx(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlgEx::IDD, pParent)
	, m_pCurPageWnd(0)
	, pageNomal()
	, pageTab()
	, pageNew()
	, pageSecurity()
	, pageFavorites()
	, pageToolbar()
	, pageAddress()
	, pageSearch()
	, pageProxy()
	, pageFilter()
	, pageKeyboard()
	, pageMouse()
	, pageMouse2()
	, pageAlert()
	, pagePopup()
	, pageEditMenu()
	, pageCustomMenu()
	, pageDownload()
	, pageAccel()
	, pageStartup()
	, pageClosedUrl()
	, pageSidebar()
	, pageLinkbar()
	, pageExit()
	, pageThumbnail()
	//, m_strPage[PAGE_COUNT]
	//, m_wndPage[PAGE_COUNT]
	//, m_nPageID[PAGE_COUNT]
{
	ZeroMemory(m_wndPage, sizeof m_wndPage);
	ZeroMemory(m_nPageID, sizeof m_nPageID);
	//{{AFX_DATA_INIT(COptionDlgEx)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void COptionDlgEx::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDlgEx)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDlgEx, CDialog)
	//{{AFX_MSG_MAP(COptionDlgEx)
	ON_WM_CREATE()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree1)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
//	ON_MESSAGE(WM_GETTRACKPOPUP, OnTrackPopupMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDlgEx bZ[W nh

int COptionDlgEx::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	m_pCurPageWnd = NULL;

	// ̑-̑
	g_Options.LoadSetting();
	return 0;
}

BOOL COptionDlgEx::OnInitDialog()
{
	CDialog::OnInitDialog();

	for (int i = 0; i < PAGE_COUNT; i++) {
		m_wndPage[i] = 0;
	}

	CTreeCtrl* pTree = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	HTREEITEM item;
	item = AddPage(TVI_ROOT, &pageNomal, _T("S"), IDD_OPTIONPAGE_NOMAL );

	pTree->SelectItem(item);

	item = pTree->InsertItem( _T("^u"), 0, 0, TVI_ROOT, TVI_LAST );
	AddPage(item, &pageTab, _T("^uo[")		 , IDD_OPTIONPAGE_TAB);
	AddPage(item, &pageNew, _T("VK^uŊJ") , IDD_OPTIONPAGE_NEW);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("ZLeB")  , 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageSecurity , _T("ݒ")  , IDD_OPTIONPAGE_SECURITY);
	AddPage(item, &pageFilter	, _T("tB^")  , IDD_OPTIONPAGE_FILTER);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("o[")  , 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageSidebar	, _T("TCho[")	 , IDD_OPTIONPAGE_SIDEBAR);
	AddPage(item, &pageFavorites, _T("Cɓ")	 , IDD_OPTIONPAGE_FAVORITES);
	AddPage(item, &pageLinkbar	, _T("No[")	 , IDD_OPTIONPAGE_LINKBAR);
	AddPage(item, &pageAddress	, _T("AhXo[") , IDD_OPTIONPAGE_ADDRESS);
	AddPage(item, &pageSearch	, _T("o[")	 , IDD_OPTIONPAGE_SEARCH);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("NEI")	, 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageStartup	, _T("N̏")  , IDD_OPTIONPAGE_STARTUP);
	AddPage(item, &pageExit 	, _T("Ȉ")  , IDD_OPTIONPAGE_EXIT);
	AddPage(item, &pageAlert	, _T("mF@\")  , IDD_OPTIONPAGE_ALERT);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("L[{[h")	, 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageAccel	, _T("V[gJbgL[")	 , IDD_OPTIONPAGE_ACCEL);
	AddPage(item, &pageKeyboard , _T("L[[h")			 , IDD_OPTIONPAGE_KEYBOARD);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("}EX")	, 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageMouse		, _T("}EX")			 , IDD_OPTIONPAGE_MOUSE);
	AddPage(item, &pageMouse2		, _T("WFX`[")		 , IDD_OPTIONPAGE_MOUSE2);
	AddPage(item, &pageCustomMenu	, _T("ENbNj[")	 , IDD_OPTIONPAGE_CUSTOMMENU);
	pTree->Expand(item , TVE_EXPAND);

	item = pTree->InsertItem( _T("@\")  , 0 , 0 , TVI_ROOT , TVI_LAST);
	AddPage(item, &pageClosedUrl	, _T("ŋߕy[W") , IDD_OPTIONPAGE_CLOSEDURL);
	AddPage(item, &pageProxy		, _T("vNV")		 , IDD_OPTIONPAGE_PROXY);
	AddPage(item, &pagePopup		, _T("RecubN")		 , IDD_OPTIONPAGE_POPUP);
	AddPage(item, &pageThumbnail	, _T("TlC")		 , IDD_OPTIONPAGE_THUMBNAIL);
	//AddPage(item, &pageDownload	, _T("_E[h")	 , IDD_OPTIONPAGE_DOWNLOAD);
	pTree->Expand(item , TVE_EXPAND);

	SetActivePage( _T("S") );
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void COptionDlgEx::OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult)
{ // y[W̐؂ւ
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	CTreeCtrl* pTree = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	CString strItem = pTree->GetItemText( pNMTreeView->itemNew.hItem );

	if (pTree->ItemHasChildren(pNMTreeView->itemNew.hItem))
	{ // ŏ̎q
		strItem = pTree->GetItemText( pTree->GetChildItem( pNMTreeView->itemNew.hItem ) );
	}
	SetActivePage(strItem);
	*pResult = 0;
}

HTREEITEM COptionDlgEx::AddPage(HTREEITEM itemParent , CWnd* pWnd , LPCTSTR strPageName , UINT nID)
{ // y[Wǉ
	// CfbNXT
	for (int Index = 0; Index < PAGE_COUNT; Index++) {
		if (m_wndPage[Index] == NULL) {
			break;
		}
	}

	if (m_wndPage[Index]) {
		return NULL;
	}

	m_strPage[Index] = strPageName;
	m_wndPage[Index] = pWnd;
	m_nPageID[Index] = nID;

	CTreeCtrl* pTree = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	return pTree->InsertItem( strPageName, 0, 0, itemParent, TVI_LAST );

}
BOOL COptionDlgEx::SetActivePage(CString strItem)
{
	if (m_pCurPageWnd)
		m_pCurPageWnd->ShowWindow(SW_HIDE);

	for (int i = 0;i<PAGE_COUNT;i++) {
		if (strItem != m_strPage[i]) {
			continue;
		}

		if (m_wndPage[i]->m_hWnd == 0) {
			((CDialog*)m_wndPage[i])->Create(m_nPageID[i] , this);
			m_wndPage[i]->MoveWindow( 170, 0, 480, 390 );
		}
		m_pCurPageWnd = m_wndPage[i];
	}

	if (m_pCurPageWnd) {
		m_pCurPageWnd->ShowWindow(SW_SHOW);
		return TRUE;
	}
	else
		return FALSE;
}

void COptionDlgEx::OnOK()
{
	// qEBhEIDOK
	CDialog* pPageWnd = NULL;

	for (int i = 0;i<PAGE_COUNT;i++) {
		if (m_wndPage[i]->m_hWnd != 0) {
			pPageWnd = (CDialog*)m_wndPage[i];
			break;
		}
	}

	while (pPageWnd != NULL) {
		pPageWnd->UpdateData(TRUE);
		pPageWnd->SendMessage( WM_COMMAND, IDOK );

		pPageWnd = static_cast<CDialog*>( pPageWnd->GetNextWindow() );
	}

	// ۑ
	g_Options.SaveIni();
	CDialog::OnOK();
}

void COptionDlgEx::OnDestroy()
{
	// ݒy[WJ
	CDialog* pPageWnd = NULL;

	for (int i = 0; i < PAGE_COUNT; i++) {
		if (::IsWindow(m_wndPage[i]->m_hWnd)) {
			pPageWnd = static_cast<CDialog*>( m_wndPage[i] );
			break;
		}
	}

	while (pPageWnd != NULL) {
		CWnd* pNextPage = pPageWnd->GetNextWindow();
		pPageWnd->DestroyWindow();

		pPageWnd = static_cast<CDialog*>( pNextPage );
	}
	CDialog::OnDestroy();
}
