/**
 *	@file HtmlViewDropTarget.cpp
 *	@brief	HtmlView ւ̃hbvΉ.
 *	@note
 *	-	PatriotView OnGetDropTarget ŏDꍇAHtmlViewExSiteKɂ
 *		QueryStatus, Exec ǂɂKv肻HƎv߂sB
 */

#include "stdafx.h"
#include "patriot.h"
#include "DropTarget.h"
#include "MainFrm.h"
#include "patriotGlobal.h"
#include "patriotView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#if 0
BEGIN_MESSAGE_MAP(CHtmlViewDropTarget, COleDropTarget)
END_MESSAGE_MAP()

BEGIN_INTERFACE_MAP(CHtmlViewDropTarget, COleDropTarget)
	INTERFACE_PART(CHtmlViewDropTarget, IID_IOleCommandTarget, COleCmdTarget 	)
END_INTERFACE_MAP()

IMPLEMENT_IUNKNOWN( CHtmlViewDropTarget, COleCmdTarget	  );
#endif



/////////////////////////////////////////////////////////////////////////////
// \z/
/////////////////////////////////////////////////////////////////////////////

CHtmlViewDropTarget::CHtmlViewDropTarget()
{

}

CHtmlViewDropTarget::~CHtmlViewDropTarget()
{

}



DROPEFFECT CHtmlViewDropTarget::OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return DROPEFFECT_COPY;
}



#if 1
DROPEFFECT CHtmlViewDropTarget::OnDropEx( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point )
{ // hbv
  #if 1
	enum { max_path = 1024 };		//+++ Url  MAX_PATH(260)Ă...0x8000? ... ܂łĂȂ̂.
  #else
	enum { max_path = MAX_PATH };
  #endif
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	// f[^擾
	// TEXT
	TCHAR lpszText[max_path];
	if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
		HGLOBAL 	 hData = pDataObject->GetGlobalData(BURA_CF_TEXT);
		const TCHAR* ptr   = static_cast<const TCHAR*>( ::GlobalLock(hData) );
		lstrcpyn(lpszText, ptr, max_path);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}

	// FILE
	enum { FILE_NUM = 128 };	//+++
	TCHAR	lpszFiles[FILE_NUM][_MAX_PATH];
	UINT 	nFiles	= 0;
	if (pDataObject->IsDataAvailable(CF_HDROP)) {
		HGLOBAL hData 	  = pDataObject->GetGlobalData(CF_HDROP);
		HDROP	hDropInfo = static_cast<HDROP>( ::GlobalLock(hData) );

		nFiles = ::DragQueryFile( hDropInfo, (UINT)-1, NULL, 0 );
		if (nFiles > FILE_NUM)	//+++
			nFiles = FILE_NUM;
		for (UINT nFile = 0; nFile < nFiles; nFile++) {
			::DragQueryFile( hDropInfo, nFile, lpszFiles[nFile], _MAX_PATH );
		}
		::DragFinish(hDropInfo);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}

	if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
		if (::_tcsstr((lpszText),_T("://"))) {
			CHtmlView2* pView = ((CPatriotApp*)AfxGetApp())->NewTab( 4 );
			pView->Navigate( lpszText );
		} else {
			CComboBox* pCombo = (CComboBox*)pMainFrame->m_wndSearchBar.GetDlgItem(IDC_COMBO1);
			pCombo->SetWindowText(lpszText);
			//pCombo->SetFocus();
			pMainFrame->m_wndSearchBar.GoUrl();
		}
		return DROPEFFECT_COPY;
	}

	return DROPEFFECT_NONE;
}
#else
DROPEFFECT CHtmlViewDropTarget::OnDropEx( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point )
{ // hbv
  #if 1
	enum { max_path = 1024 };		//+++ Url  MAX_PATH(260)Ă...0x8000? ... ܂łĂȂ̂.
  #else
	enum { max_path = MAX_PATH };
  #endif
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	// f[^擾
	// TEXT
	TCHAR lpszText[max_path];
	if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
		HGLOBAL 	 hData = pDataObject->GetGlobalData(BURA_CF_TEXT);
		const TCHAR* ptr   = static_cast<const TCHAR*>( ::GlobalLock(hData) );
		lstrcpyn(lpszText, ptr, max_path);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}

	// FILE
	enum { FILE_NUM = 128 };	//+++
	TCHAR	lpszFiles[FILE_NUM][_MAX_PATH];
	UINT 	nFiles	= 0;
	if (pDataObject->IsDataAvailable(CF_HDROP)) {
		HGLOBAL hData 	  = pDataObject->GetGlobalData(CF_HDROP);
		HDROP	hDropInfo = static_cast<HDROP>( ::GlobalLock(hData) );

		nFiles = ::DragQueryFile( hDropInfo, (UINT)-1, NULL, 0 );
		if (nFiles > FILE_NUM)	//+++
			nFiles = FILE_NUM;
		for (UINT nFile = 0; nFile < nFiles; nFile++) {
			::DragQueryFile( hDropInfo, nFile, lpszFiles[nFile], _MAX_PATH );
		}
		::DragFinish(hDropInfo);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}

	if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
		if (::_tcsstr((lpszText),_T("://"))) {
			CHtmlView2* pView = ((CPatriotApp*)AfxGetApp())->NewTab( 4 );
			pView->Navigate( lpszText );
		} else {
			CComboBox* pCombo = (CComboBox*)pMainFrame->m_wndSearchBar.GetDlgItem(IDC_COMBO1);
			pCombo->SetWindowText(lpszText);
			pCombo->SetFocus();
		}
		return DROPEFFECT_COPY;
	}

	return DROPEFFECT_NONE;
}
#endif



// ============================================================================
#if 0	// s. ^Ⴄ񂾂瓖R

// HtmlViewExSite.cpp Rsy
STDMETHODIMP CHtmlViewExSite::XOleCmdTarget::QueryStatus(
			/* [unique][in] */ 		const GUID __RPC_FAR*	pguidCmdGroup,
			/* [in] */ 				ULONG 					cCmds,
			/* [out][in][size_is] */OLECMD __RPC_FAR 		prgCmds[	],
			/* [unique][out][in] */ OLECMDTEXT __RPC_FAR*	pCmdText)
{
	METHOD_PROLOGUE(CHtmlViewExSite, OleCmdTarget);

	// Ver1.0.03 uV[gJbg̍쐬vɂȂ
	return OLECMDERR_E_NOTSUPPORTED;
	//return E_FAIL;
}


// HtmlViewExSite.cpp Rsy
STDMETHODIMP CHtmlViewExSite::XOleCmdTarget::Exec(
			/* [unique][in] */ const GUID __RPC_FAR*	pguidCmdGroup,
			/* [in] */ DWORD 							nCmdID,
			/* [in] */ DWORD 							nCmdexecopt,
			/* [unique][in] */ VARIANT 		__RPC_FAR*	pvaIn,
			/* [unique][out][in] */ VARIANT __RPC_FAR*	pvaOut)
{
	// From DonutP
	METHOD_PROLOGUE(CHtmlViewExSite, OleCmdTarget)

	static const CLSID DONUT_CGID_DocHostCommandHandler =
	{ 0xf38bc242, 0xb950, 0x11d1, { 0x89, 0x18, 0x00, 0xc0, 0x4f, 0xc2, 0xc8, 0x36 } };

	if (pguidCmdGroup == NULL || !::IsEqualGUID(*pguidCmdGroup, DONUT_CGID_DocHostCommandHandler)){
		return OLECMDERR_E_UNKNOWNGROUP;
	}

	if (nCmdID != OLECMDID_SHOWSCRIPTERROR || !pThis->m_bKillDialog){
		return OLECMDERR_E_NOTSUPPORTED;
	}
	TRACE(_T("IScriptErrorCommandTargetImpl::Exec\n"));

	// Show Status Text
	CMDIFrameWnd* pMainFrame = static_cast<CMDIFrameWnd*>( AfxGetMainWnd() );
	if (pMainFrame) {
		pMainFrame->SetMessageText( _T("y[WŃXNvg G[܂") );
	}

	pvaOut->vt 		= VT_BOOL;
	V_BOOL(pvaOut)	= VARIANT_TRUE;

	return S_OK;
}
#endif
